package components

import (
	"context"

	"github.com/urfave/cli/v2"
	"go-micro.dev/v4/server"
)

type Component interface {
	Name() string
	Priority() int
	Initialized() bool
	Init(components *Components, context *cli.Context) error
	Stop() error
	MergeFlags(cli []cli.Flag) []cli.Flag
	Health(context context.Context) (string, bool)

	WrapperFunc(ctx context.Context, req server.Request, rsp interface{}) error
}
